diff --git a/hubs/tests/views/test_api_association.py b/hubs/tests/views/test_api_association.py
new file mode 100644
index 0000000..26eaaa5
--- /dev/null
+++ b/hubs/tests/views/test_api_association.py
@@ -0,0 +1,151 @@
+from __future__ import unicode_literals
+
+from six.moves.urllib.parse import urlparse
+
+import hubs.tests
+import hubs.models
+from hubs.app import app
+
+
+def usernames(collection): return [u.username for u in collection]
+
+
+class TestHubSubscribe(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_subscribe_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/subscribe'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_subscribe_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/subscribe'.format(hub.name),
+                                 follow_redirects=True)
+            self.assertEqual(resp.status_code, 200)
+            # Need to find the Hub again to avoid DetachedInstanceError
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname in usernames(h.subscribers))
+
+
+class TestHubUnsubscribe(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_unsubscribe_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/unsubscribe'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_unsubscribe_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        # Need a real user model to subscribe to the hub
+        User = hubs.models.User.by_username(self.user.nickname)
+        hub.subscribe(User)
+
+        self.assertTrue(self.user.nickname in usernames(hub.subscribers))
+
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/unsubscribe'.format(hub.name),
+                                 follow_redirects=True)
+            self.assertEqual(resp.status_code, 200)
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname not in usernames(h.subscribers))
+
+
+class TestHubStar(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_star_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/star'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_star_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/star'.format(hub.name),
+                                 follow_redirects=True)
+
+            self.assertEqual(resp.status_code, 200)
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname in usernames(h.stargazers))
+
+
+class TestHubUnstar(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_unstar_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/unstar'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_unstar_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        # Need a real user model to subscribe to the hub
+        User = hubs.models.User.by_username(self.user.nickname)
+        hub.subscribe(User, role='stargazer')
+
+        self.assertTrue(self.user.nickname in [u.username for
+                                               u in hub.stargazers])
+
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/unstar'.format(hub.name),
+                                 follow_redirects=True)
+            self.assertEqual(resp.status_code, 200)
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname not in usernames(h.stargazers))
+
+
+class TestHubJoin(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_join_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/join'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_join_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/join'.format(hub.name),
+                                 follow_redirects=True)
+
+            self.assertEqual(resp.status_code, 200)
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname in usernames(h.members))
+
+
+class TestHubLeave(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('decause')
+
+    def test_leave_redirects_when_logged_out(self):
+        hub = hubs.models.Hub.by_name('infra')
+        resp = self.app.post('/api/hubs/{}/leave'.format(hub.name),
+                             follow_redirects=False)
+        self.assertEqual(resp.status_code, 302)
+        self.assertEqual(urlparse(resp.location).path, '/login')
+
+    def test_star_when_logged_in(self):
+        hub = hubs.models.Hub.by_name('infra')
+        # Need a real user model to subscribe to the hub
+        User = hubs.models.User.by_username(self.user.nickname)
+        hub.subscribe(User, role='member')
+
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post('/api/hubs/{}/leave'.format(hub.name),
+                                 follow_redirects=True)
+
+            self.assertEqual(resp.status_code, 200)
+            h = hubs.models.Hub.by_name('infra')
+            self.assertTrue(self.user.nickname not in usernames(h.members))
diff --git a/hubs/tests/views/test_api_hub_config.py b/hubs/tests/views/test_api_hub_config.py
new file mode 100644
index 0000000..b542ce1
--- /dev/null
+++ b/hubs/tests/views/test_api_hub_config.py
@@ -0,0 +1,185 @@
+from __future__ import unicode_literals
+
+import datetime
+
+from flask import json
+
+from hubs.app import app
+from hubs.models import Hub, User
+from hubs.tests import APPTest, FakeAuthorization, auth_set
+
+
+class TestAPIHubConfig(APPTest):
+
+    def test_get(self):
+        hub = Hub.by_name('ralph')
+        hub.last_refreshed = datetime.datetime(2017, 1, 1, 0, 0, 0)
+        self.session.commit()
+        user = FakeAuthorization('ralph')
+        response = self.check_url("/api/hubs/ralph/config", user=user)
+        expected_data = {
+            "user_hub": True,
+            "config": {
+                "avatar": "https://seccdn.libravatar.org/avatar/"
+                          "9c9f7784935381befc302fe3c814f9136e7a339"
+                          "53d0318761669b8643f4df55c?s=312&d=retro",
+                'chat_channel': None,
+                'chat_domain': None,
+                "left_width": 8,
+                "right_width": 4,
+                "summary": "Ralph",
+                "visibility": "public",
+            },
+            "mtime": "Sun, 01 Jan 2017 00:00:00 GMT",
+            "users": {
+                "owner": [
+                    {"username": "ralph", "fullname": "Ralph"},
+                ],
+                "member": [],
+            },
+            "name": "ralph",
+        }
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(
+            response_data, {"status": "OK", "data": expected_data})
+
+    def test_private_get(self):
+        hub = Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        self.session.commit()
+        # Private hubs are not accessible to anonymous users.
+        response = self.check_url("/api/hubs/ralph/config", code=403)
+        self.assertDictEqual(
+            json.loads(response.get_data(as_text=True)),
+            {
+              "hub": "ralph",
+              "message": "This hub is for members only.",
+              "status": "ERROR"
+            }
+        )
+        # But they are accessible to members.
+        decause = User.by_username("decause")
+        hub.subscribe(decause, role='member')
+        self.check_url(
+            "/api/hubs/ralph/config", user=FakeAuthorization("decause"))
+
+    def test_put(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/ralph/config',
+                content_type="application/json",
+                data=json.dumps({
+                    "config": {
+                        "summary": "changed value",
+                        "chat_domain": "",
+                    }
+                })
+            )
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        hub_config = Hub.query.get("ralph").config
+        self.assertEqual(hub_config.summary, "changed value")
+        self.assertEqual(
+            hub_config.chat_domain,
+            app.config["CHAT_NETWORKS"][0]["domain"])
+
+    def test_put_unknown_data(self):
+        # Unknown PUT data is silently ignored
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/ralph/config',
+                content_type="application/json",
+                data=json.dumps({"config": {"non_existant": "dummy"}}))
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "ERROR")
+        self.assertEqual(result_data["message"], "Invalid value(s)")
+        self.assertIn("non_existant", result_data["fields"])
+        self.assertEqual(
+            result_data["fields"]["non_existant"],
+            "Unexpected parameter."
+            )
+
+    def test_put_invalid_chat_domain(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/ralph/config',
+                content_type="application/json",
+                data=json.dumps({"config": {"chat_domain": "dummy"}}))
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "ERROR")
+        self.assertEqual(result_data["message"], "Invalid value(s)")
+        self.assertIn("chat_domain", result_data["fields"])
+        self.assertEqual(
+            result_data["fields"]["chat_domain"],
+            "Unsupported chat domain."
+            )
+
+    def test_put_unauthorized(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/decause/config',
+                content_type="application/json",
+                data=json.dumps({"config": {"summary": "Defaced!"}}))
+        self.assertEqual(result.status_code, 403)
+        hub_config = Hub.query.get("decause").config
+        self.assertEqual(hub_config.summary, "Decause")
+
+    def test_suggest_users_no_filter(self):
+        user = FakeAuthorization('ralph')
+        expected = [
+            dict(username=u.username, fullname=u.fullname)
+            for u in User.query.order_by(User.username).all()
+            ]
+        # Check without filter
+        response = self.check_url(
+            "/api/hubs/ralph/config/suggest-users", user=user)
+        result_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["data"], expected)
+
+    def test_suggest_users_filter_owners(self):
+        # Filters on owners
+        user = FakeAuthorization('ralph')
+        expected = [
+            dict(username=u.username, fullname=u.fullname)
+            for u in
+            User.query.order_by(User.username).filter(
+                User.username != "ralph").all()
+            ]
+        response = self.check_url(
+            "/api/hubs/ralph/config/suggest-users?exclude-role=owner",
+            user=user)
+        result_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["data"], expected)
+
+    def test_suggest_users_filter_members(self):
+        # Filters on members
+        user = FakeAuthorization('ralph')
+        hub = Hub.get('ralph')
+        decause = User.query.get("decause")
+        devyani7 = User.query.get("devyani7")
+        hub.subscribe(decause, "member")
+        hub.subscribe(devyani7, "member")
+        expected = [
+            dict(username=u.username, fullname=u.fullname)
+            for u in
+            User.query.order_by(
+                User.username
+            ).filter(
+                User.username != "decause",
+                User.username != "devyani7"
+            ).all()]
+        response = self.check_url(
+            "/api/hubs/ralph/config/suggest-users?exclude-role=member",
+            user=user)
+        result_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertListEqual(result_data["data"], expected)
diff --git a/hubs/tests/views/test_api_hub_widget.py b/hubs/tests/views/test_api_hub_widget.py
new file mode 100644
index 0000000..5684d29
--- /dev/null
+++ b/hubs/tests/views/test_api_hub_widget.py
@@ -0,0 +1,240 @@
+from __future__ import unicode_literals
+
+from flask import json
+
+from hubs.app import app
+from hubs.models import Hub, User, Widget
+from hubs.widgets import registry
+from hubs.tests import APPTest, FakeAuthorization, auth_set
+
+
+class TestAPIHubWidgets(APPTest):
+
+    def test_get_widgets(self):
+        expected_ids = [35, 36, 34, 37, 38, 39, 40, 41, 42, 43, 44, 56]
+        response = self.check_url("/api/hubs/ralph/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertListEqual(
+            [w["idx"] for w in response_data["data"]],
+            expected_ids)
+
+    def test_get_widgets_private(self):
+        hub = Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        self.session.commit()
+        # Private hubs are not accessible to anonymous users.
+        response = self.check_url("/api/hubs/ralph/widgets/", code=403)
+        self.assertDictEqual(
+            json.loads(response.get_data(as_text=True)),
+            {
+              "hub": "ralph",
+              "message": "This hub is for members only.",
+              "status": "ERROR"
+            }
+        )
+        # But they are accessible to members.
+        decause = User.by_username("decause")
+        hub.subscribe(decause, role='member')
+        self.check_url(
+            "/api/hubs/ralph/widgets/", user=FakeAuthorization("decause"))
+
+    def test_get_widgets_preview(self):
+        hub = Hub.by_name('ralph')
+        hub.config.visibility = "preview"
+        meetings = Widget.query.filter_by(
+            hub=hub, plugin="meetings").first()
+        # set the widget to "restricted"
+        meetings.visibility = "restricted"
+        # Restricted widgets in preview hubs aren't displayed to
+        # anonymous users.
+        response = self.check_url("/api/hubs/ralph/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertNotIn(
+            "meetings", [w["name"] for w in response_data["data"]])
+        # But they are displayed to members.
+        response = self.check_url(
+            "/api/hubs/ralph/widgets/", user=FakeAuthorization('ralph'))
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertIn(
+            "meetings", [w["name"] for w in response_data["data"]])
+
+    def test_get_removed_widget(self):
+        hub = Hub.get("ralph")
+        widget = Widget(
+            hub=hub, plugin="does-not-exist",
+            left=True, index=-1, _config="{}")
+        self.session.add(widget)
+        response = self.check_url(
+            "/api/hubs/ralph/widgets/", user=FakeAuthorization('ralph'))
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertNotIn(
+            "does-not-exist", [w["name"] for w in response_data["data"]])
+
+    def test_get_available(self):
+        response = self.check_url("/api/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertListEqual(
+            [w["name"] for w in response_data["data"]],
+            list(registry.keys()))
+
+    def test_post_invalid_request(self):
+        invalid_data = [
+            {
+                "position": "left",
+                'config': {},
+            }, {
+                'name': 'about',
+                'position': 'right',
+            }, {
+                'name': 'about',
+                'config': {},
+            }, {
+                'name': 'about',
+                'config': {},
+                'position': 'invalid_position',
+            },
+        ]
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            for data in invalid_data:
+                result = self.app.post(
+                    '/api/hubs/ralph/widgets/',
+                    content_type="application/json",
+                    data=json.dumps(data))
+                self.assertEqual(result.status_code, 400)
+                expected_str = 'Invalid request sent'
+                self.assertIn(expected_str, result.get_data(as_text=True))
+
+    def test_post_unknown_widget(self):
+        invalid_data = [
+            {
+                'name': 'invalid_widget_name',
+                'config': {},
+                'position': 'right',
+            },
+        ]
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            for data in invalid_data:
+                result = self.app.post(
+                    '/api/hubs/ralph/widgets/',
+                    content_type="application/json",
+                    data=json.dumps(data))
+                self.assertEqual(result.status_code, 400)
+                expected_str = 'Unknown widget'
+                self.assertIn(expected_str, result.get_data(as_text=True))
+
+    def test_post_valid_widget_name_no_config(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            data = {
+                'name': 'memberships',
+                'position': 'right',
+                "config": {},
+                }
+            result = self.app.post(
+                '/api/hubs/ralph/widgets/',
+                content_type="application/json",
+                data=json.dumps(data))
+        self.assertEqual(result.status_code, 200)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            {"status": "OK"})
+        response = self.check_url("/api/hubs/ralph/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertIn("memberships",
+                      [w["name"] for w in response_data["data"]])
+
+    def test_post_valid_widget_name_with_config(self):
+        self.assertEqual(
+            Widget.query.filter(
+                Hub.name == "ralph",
+                Widget.plugin == "about",
+            ).count(), 1)
+        data = {
+            "name": "about",
+            "config": {'text': 'text of widget'},
+            'position': 'right',
+            }
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.post(
+                '/api/hubs/ralph/widgets/',
+                content_type="application/json",
+                data=json.dumps(data))
+        self.assertEqual(result.status_code, 200)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            {"status": "OK"})
+        self.assertEqual(
+            Widget.query.filter(
+                Hub.name == "ralph",
+                Widget.plugin == "about",
+            ).count(), 2)
+
+
+class TestAPIHubWidget(APPTest):
+
+    def test_get_logged_in(self):
+        user = FakeAuthorization('ralph')
+        response = self.check_url("/api/hubs/ralph/widgets/37/", user=user)
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "OK")
+        self.assertEqual(response_data["data"]["name"], "fedmsgstats")
+
+    def test_get_logged_out(self):
+        hub = Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        self.session.commit()
+        response = self.check_url("/api/hubs/ralph/widgets/31/", code=403)
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "ERROR")
+
+    def test_put_empty_data_logged_in(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/ralph/widgets/37/',
+                content_type="application/json",
+                data=json.dumps({}))
+        self.assertEqual(result.status_code, 200)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            {"status": "OK"})
+
+    def test_put_unauthorized(self):
+        user = FakeAuthorization('decause')
+        with auth_set(app, user):
+            result = self.app.put(
+                '/api/hubs/ralph/widgets/37/',
+                content_type="application/json",
+                data=json.dumps({"config": {"text": "Defaced!"}}))
+        self.assertEqual(result.status_code, 403)
+
+    def test_delete(self):
+        user = FakeAuthorization('ralph')
+        with auth_set(app, user):
+            result = self.app.delete('/api/hubs/ralph/widgets/37/')
+        self.assertEqual(result.status_code, 200)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            {"status": "OK"})
+        response = self.check_url("/api/hubs/ralph/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertNotIn(37, [w["idx"] for w in response_data["data"]])
+
+    def test_delete_unauthorized(self):
+        user = FakeAuthorization('decause')
+        with auth_set(app, user):
+            response = self.app.delete('/api/hubs/ralph/widgets/37/')
+        self.assertEqual(response.status_code, 403)
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertEqual(response_data["status"], "ERROR")
+        response = self.check_url("/api/hubs/ralph/widgets/")
+        response_data = json.loads(response.get_data(as_text=True))
+        self.assertIn(37, [w["idx"] for w in response_data["data"]])
diff --git a/hubs/tests/widgets/test_about.py b/hubs/tests/widgets/test_about.py
index 1cb4ab1..703af25 100644
--- a/hubs/tests/widgets/test_about.py
+++ b/hubs/tests/widgets/test_about.py
@@ -1,25 +1,10 @@
 from __future__ import unicode_literals
 
-import json
-
-from hubs.tests import FakeAuthorization, widget_instance
 from . import WidgetTest
 
 
 class TestAbout(WidgetTest):
     plugin = 'about'  # The name in hubs.widgets.registry
 
-    def test_data_simple(self):
-        widget = widget_instance('ralph', self.plugin)
-        user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/%i/json' % widget.idx, user)
-        data = json.loads(response.get_data(as_text=True))
-        self.assertDictEqual(data['data'], {
-            'text': 'Testing.',
-            'title': "<span class='glyphicon glyphicon-info-sign' "
-                     "aria-hidden='true'></span> About",
-            'edit_mode': False,
-        })
-
     def test_view_authz(self):
         self._test_view_authz()
diff --git a/hubs/tests/widgets/test_badges.py b/hubs/tests/widgets/test_badges.py
index a984070..9151ed2 100644
--- a/hubs/tests/widgets/test_badges.py
+++ b/hubs/tests/widgets/test_badges.py
@@ -1,11 +1,9 @@
 from __future__ import unicode_literals
 
-import json
-
 from mock import Mock, patch
 
 import hubs.widgets
-from hubs.tests import FakeAuthorization, widget_instance
+from hubs.tests import widget_instance
 from . import WidgetTest
 
 
@@ -14,11 +12,9 @@ class TestBadges(WidgetTest):
 
     def test_data_simple(self):
         widget = widget_instance('ralph', self.plugin)
-        user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/%i/json' % widget.idx, user)
-        data = json.loads(response.get_data(as_text=True))
-        self.assertEquals(data['plugin'], 'badges')
-        self.assertIn('assertions', data['data'].keys())
+        func = widget.module.get_cached_functions()['GetBadges']
+        result = func(widget)()
+        self.assertIn('assertions', result.keys())
 
     def test_should_invalidate_wrong_topic(self):
         widget = widget_instance('ralph', self.plugin)
diff --git a/hubs/tests/widgets/test_contact.py b/hubs/tests/widgets/test_contact.py
index 7e06862..f011392 100644
--- a/hubs/tests/widgets/test_contact.py
+++ b/hubs/tests/widgets/test_contact.py
@@ -76,9 +76,10 @@ class ContactsTest(WidgetTest):
 
     def test_data_simple(self):
         user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/%i/json' % self.widget_idx, user)
-        data = json.loads(response.get_data(as_text=True))
-        self.assertDictEqual(data['data'], {
+        widget = Widget.query.get(self.widget_idx)
+        response = self.check_url(
+            '/ralph/w/contact/%i/' % self.widget_idx, user)
+        self.assertDictEqual(response.context, {
             'account_age': 'Oct 2010',
             'email': 'ralph@fedoraproject.org',
             'ircnick': 'ralph',
@@ -88,6 +89,8 @@ class ContactsTest(WidgetTest):
             'timezone': 'UTC',
             'usergroup': True,
             'edit_mode': False,
+            'widget': widget.module,
+            'widget_instance': widget,
         })
 
     def test_view_authz(self):
diff --git a/hubs/tests/widgets/test_fedmsgstats.py b/hubs/tests/widgets/test_fedmsgstats.py
index 2a4508a..91778b4 100644
--- a/hubs/tests/widgets/test_fedmsgstats.py
+++ b/hubs/tests/widgets/test_fedmsgstats.py
@@ -1,7 +1,5 @@
 from __future__ import unicode_literals
 
-import json
-
 from hubs.tests import FakeAuthorization, widget_instance
 from . import WidgetTest
 
@@ -12,9 +10,9 @@ class TestFedmsgStats(WidgetTest):
     def test_data_simple(self):
         widget = widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/%i/json' % widget.idx, user)
-        data = json.loads(response.get_data(as_text=True))
-        self.assertDictEqual(data['data'], {
+        response = self.check_url(
+            '/ralph/w/%s/%i/' % (self.plugin, widget.idx), user)
+        self.assertDictEqual(response.context, {
             'fedmsgs': 83854,
             'fedmsgs_text': '83,854',
             'subscribers': [],
@@ -22,9 +20,11 @@ class TestFedmsgStats(WidgetTest):
             'subscribers_text': '0',
             'subscribed_text': '0',
             'username': 'ralph',
-            'hub_subscribe_url': '/api/hub/ralph/subscribe',
-            'hub_unsubscribe_url': '/api/hub/ralph/unsubscribe',
+            'hub_subscribe_url': '/api/hubs/ralph/subscribe',
+            'hub_unsubscribe_url': '/api/hubs/ralph/unsubscribe',
             'edit_mode': False,
+            'widget': widget.module,
+            'widget_instance': widget,
         })
 
     def test_view_authz(self):
diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index 2e33ade..5a489d3 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -117,57 +117,6 @@ class HalpViewsTestCase(WidgetTest):
     def test_view_authz(self):
         self._test_view_authz()
 
-    def test_json(self):
-        response = self.app.get('/ralph/%i/json' % self.widget.idx)
-        self.assertEqual(response.status_code, 200)
-        data = json.loads(response.get_data(as_text=True))
-        self.assertEquals(data['plugin'], 'halp')
-        self.assertIn('hubs', data['data'].keys())
-
-    def test_config_add(self):
-        user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/w/halp/add?position=right', user)
-        self.assertEqual(response.context["mode"], "add")
-        self.assertEqual(response.context["initial"], {
-            "hubs": ["ralph"], "per_page": 4,
-            })
-        self.assertEqual(
-            response.context["url"], "/ralph/add/halp?position=right")
-
-    def test_config_edit(self):
-        user = FakeAuthorization('ralph')
-        url = '/ralph/w/halp/%i/config' % self.widget.idx
-        response = self.check_url(url, user)
-        self.assertEqual(response.context["mode"], "edit")
-        self.assertEqual(response.context["initial"], {
-            'hubs': ['fedora-devel'],
-            'per_page': 3,
-            })
-        self.assertEqual(
-            response.context["url"], "/ralph/%i/edit" % self.widget.idx)
-
-    def test_config_authz(self):
-        urls = [
-            '/ralph/w/halp/add',
-            '/ralph/w/halp/%i/config' % self.widget.idx,
-            ]
-        # Anonymous
-        for url in urls:
-            self.check_url(url, None, 403)
-        # Logged-in
-        user = FakeAuthorization('decause')
-        for url in urls:
-            self.check_url(url, user, 403)
-        # Member
-        hub = Hub.query.get("ralph")
-        hub.subscribe(User.query.get("decause"), "member")
-        for url in urls:
-            self.check_url(url, user, 403)
-        # Owner
-        user = FakeAuthorization('ralph')
-        for url in urls:
-            self.check_url(url, user, 200)
-
     def test_config_hubs_suggest(self):
         response = self.app.get('/w/halp/hubs')
         self.assertEqual(response.status_code, 200)
